/* Tabela DESPERCIA: DESPERCIA */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela DESPERCIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela DESPERCIA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_DESPERCIA
AFTER DELETE OR INSERT OR UPDATE
ON DESPERCIA FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.DTINIDESC IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIniDesc=' || :OLD.DTINIDESC;
      END IF;
      
      IF :OLD.DTFIMDESC IS NOT NULL THEN
         V_DESC := V_DESC || ' DtFimDesc=' || :OLD.DTFIMDESC;
      END IF;
      
      IF :OLD.VRPERDESC IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPerDesc=' || :OLD.VRPERDESC;
      END IF;
      
      IF :OLD.VRTOTDESC IS NOT NULL THEN
         V_DESC := V_DESC || ' VrTotDesc=' || :OLD.VRTOTDESC;
      END IF;
      
      IF :OLD.VRUTIDESC IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUtiDesc=' || :OLD.VRUTIDESC;
      END IF;
      
      IF :OLD.VRUTINOTA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUtiNota=' || :OLD.VRUTINOTA;
      END IF;
      
      IF :OLD.DSDESCCONT IS NOT NULL THEN
         V_DESC := V_DESC || ' DsDescCont=' || :OLD.DSDESCCONT;
      END IF;
      
      IF :OLD.DTULTATUDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtuDCia=' || :OLD.DTULTATUDCIA;
      END IF;
      
      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDCIA || '|' || :OLD.DTINIDESC; 
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL   <> :NEW.CDFILIAL )OR
            (:OLD.CDCIA      <> :NEW.CDCIA    )OR
            (:OLD.DTINIDESC  <> :NEW.DTINIDESC)OR
            (:OLD.DTFIMDESC  <> :NEW.DTFIMDESC)OR
            (:OLD.VRPERDESC  <> :NEW.VRPERDESC)OR
            (:OLD.VRTOTDESC  <> :NEW.VRTOTDESC)OR
            (:OLD.VRUTIDESC  <> :NEW.VRUTIDESC)OR
            (:OLD.VRUTINOTA  <> :NEW.VRUTINOTA)OR
            (NVL(:OLD.DSDESCCONT, ' ')        <> NVL(:NEW.DSDESCCONT, ' ')) OR
            (NVL(:OLD.DTULTATUDCIA, SYSDATE) <> NVL(:NEW.DTULTATUDCIA, SYSDATE)) THEN
            
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;
            
            IF NVL(:OLD.DTINIDESC, SYSDATE) <> NVL(:NEW.DTINIDESC, SYSDATE) THEN
               V_DESC := V_DESC || ' DtIniDesc=' || :OLD.DTINIDESC || '|' || :NEW.DTINIDESC;
            END IF;
            
            IF NVL(:OLD.DTFIMDESC, SYSDATE) <> NVL(:NEW.DTFIMDESC, SYSDATE) THEN
               V_DESC := V_DESC || ' DtFimDesc=' || :OLD.DTFIMDESC || '|' || :NEW.DTFIMDESC;
            END IF;
            
            IF NVL(:OLD.VRPERDESC, 0) <> NVL(:NEW.VRPERDESC, 0) THEN
               V_DESC := V_DESC || ' VrPerDesc=' || :OLD.VRPERDESC || '|' || :NEW.VRPERDESC;
            END IF;
            
            IF NVL(:OLD.VRTOTDESC, 0) <> NVL(:NEW.VRTOTDESC, 0) THEN
               V_DESC := V_DESC || ' VrTotDesc=' || :OLD.VRTOTDESC || '|' || :NEW.VRTOTDESC;
            END IF;
            
            IF NVL(:OLD.VRUTIDESC, 0) <> NVL(:NEW.VRUTIDESC, 0) THEN
               V_DESC := V_DESC || ' VrUtiDesc=' || :OLD.VRUTIDESC || '|' || :NEW.VRUTIDESC;
            END IF;
            
            IF NVL(:OLD.VRUTINOTA, 0) <> NVL(:NEW.VRUTINOTA, 0) THEN
               V_DESC := V_DESC || ' VrUtiNota=' || :OLD.VRUTINOTA || '|' || :NEW.VRUTINOTA;
            END IF;
            
            IF NVL(:OLD.DSDESCCONT, ' ') <> NVL(:NEW.DSDESCCONT, ' ') THEN
               V_DESC := V_DESC || ' DsDescCont=' || :OLD.DSDESCCONT || '|' || :NEW.DSDESCCONT;
            END IF;
            
            IF NVL(:OLD.DTULTATUDCIA, SYSDATE) <> NVL(:NEW.DTULTATUDCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtuDCia=' || :OLD.DTULTATUDCIA || '|' || :NEW.DTULTATUDCIA;
            END IF;
            
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDCIA || '|' || :OLD.DTINIDESC;      
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
         
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' CdCia=' || :NEW.CDCIA;
         END IF;
         
           IF NVL(:OLD.DTINIDESC, SYSDATE) <> NVL(:NEW.DTINIDESC, SYSDATE) THEN
            V_DESC := V_DESC || ' DtIniDesc=' || :NEW.DTINIDESC;
         END IF;
         
         IF NVL(:OLD.DTFIMDESC, SYSDATE) <> NVL(:NEW.DTFIMDESC, SYSDATE) THEN
            V_DESC := V_DESC || ' DtFimDesc=' || :NEW.DTFIMDESC;
         END IF;
         
         IF NVL(:OLD.VRPERDESC, 0) <> NVL(:NEW.VRPERDESC, 0) THEN
            V_DESC := V_DESC || ' VrPerDesc=' || :NEW.VRPERDESC;
         END IF;
         
         IF NVL(:OLD.VRTOTDESC, 0) <> NVL(:NEW.VRTOTDESC, 0) THEN
            V_DESC := V_DESC || ' VrTotDesc=' || :NEW.VRTOTDESC;
         END IF;
         
         IF NVL(:OLD.VRUTIDESC, 0) <> NVL(:NEW.VRUTIDESC, 0) THEN
            V_DESC := V_DESC || ' VrUtiDesc=' || :NEW.VRUTIDESC;
         END IF;
         
         IF NVL(:OLD.VRUTINOTA, 0) <> NVL(:NEW.VRUTINOTA, 0) THEN
            V_DESC := V_DESC || ' VrUtiNota=' || :NEW.VRUTINOTA;
         END IF;
         
         IF NVL(:OLD.DSDESCCONT, ' ') <> NVL(:NEW.DSDESCCONT, ' ') THEN
            V_DESC := V_DESC || ' DsDescCont=' || :NEW.DSDESCCONT;
         END IF;
         
         IF NVL(:OLD.DTULTATUDCIA, SYSDATE) <> NVL(:NEW.DTULTATUDCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtuDCia=' || :NEW.DTULTATUDCIA;
         END IF;
                  
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL || '|' || :NEW.CDCIA || '|' || :NEW.DTINIDESC;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('DESPERCIA', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_DESPERCIA','5.85.xxx'); END;
/

