/* Sistemas Integrados TECNISA

Nome: 9806_GERTRGS_LOG_GER_UNIDADE.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   14/01/2016 - Jurandir Junio
*/

/* Tabela UNIDMEDIDA.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              UNIDMEDIDA, para verifio de erros */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_GER_UNIDADE' AND
                TYPE   = 'TR'                 AND
                U.UID  = O.UID                AND
                U.NAME = USER)

DROP TRIGGER LOG_GER_UNIDADE
GO


CREATE TRIGGER LOG_GER_UNIDADE
ON UNIDMEDIDA
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(500);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER       VARCHAR(1);

   DECLARE @V_SGUNIDADE_OLD     VARCHAR(4);
   DECLARE @V_DSUNIDADE_OLD    VARCHAR(10);
   DECLARE @V_DTULTATUUNID_OLD VARCHAR(10);

   DECLARE @V_SGUNIDADE_NEW     VARCHAR(4);
   DECLARE @V_DSUNIDADE_NEW    VARCHAR(10);
   DECLARE @V_DTULTATUUNID_NEW VARCHAR(10);

/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDCLIEATIV = '';
   SET @V_NRINCREST  = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         SGUNIDADE,
         DSUNIDADE,
         DTULTATUUNID,
         NULL,
         NULL,
         NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.SGUNIDADE,
         DELETED.DSUNIDADE,
         DELETED.DTULTATUUNID,

         INSERTED.SGUNIDADE,
         INSERTED.DSUNIDADE,
         INSERTED.DTULTATUUNID

      FROM
         DELETED,
         INSERTED
      WHERE
         INSERTED.SGUNIDADE  = DELETED.SGUNIDADE

      UNION ALL

      SELECT
        'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
        SGUNIDADE,
        DSUNIDADE,
        DTULTATUUNID

     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

    				 @V_SGUNIDADE_OLD,
    				 @V_DSUNIDADE_OLD,
    				 @V_DTULTATUUNID_OLD,

    				 @V_SGUNIDADE_NEW,
    				 @V_DSUNIDADE_NEW,
    				 @V_DTULTATUUNID_NEW;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_ID_TRIGGER = 'I' BEGIN

            IF @V_SGUNIDADE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'SgUnidade= ' + ISNULL(@V_SGUNIDADE_NEW,'') + ' ';
            END;

            IF @V_DSUNIDADE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'DsUnidade= ' + ISNULL(@V_DSUNIDADE_NEW,'') + ' ';
            END;

            IF @V_DTULTATUUNID_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'DtUltAtuUnid= ' + ISNULL(@V_DTULTATUUNID_NEW,'') + ' ';
            END;

           SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_TRIGGER = 'U' BEGIN

             IF (@V_SGUNIDADE_OLD <> @V_SGUNIDADE_NEW) BEGIN
                SET @V_DESC = @V_DESC + 'SgUnidade= ' + ISNULL(@V_SGUNIDADE_NEW,'') + ' ';
             END;

             IF (@V_DSUNIDADE_OLD <> @V_DSUNIDADE_NEW) BEGIN
                SET @V_DESC = @V_DESC + 'DsUnidade= ' + ISNULL(@V_DSUNIDADE_NEW,'') + ' ';
             END;

             IF (@V_DTULTATUUNID_OLD <> @V_DTULTATUUNID_NEW) BEGIN
                SET @V_DESC = @V_DESC + 'DtUltAtuUnid= ' + ISNULL(@V_DTULTATUUNID_NEW,'') + ' ';
             END;

             SET @V_IDTIPOOPER = '2';

         END;

         IF @V_ID_TRIGGER = 'D'  BEGIN

            IF @V_SGUNIDADE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'SgUnidade= ' + ISNULL(@V_SGUNIDADE_OLD,'') + ' ';
            END;

            IF @V_DSUNIDADE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'DsUnidade= ' + ISNULL(@V_DSUNIDADE_OLD,'') + ' ';
            END;

            IF @V_DTULTATUUNID_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'DtUltAtuUnid= ' + ISNULL(@V_DTULTATUUNID_OLD,'') + ' ';
            END;


            SET @V_IDTIPOOPER = '3';
         END;
      END;

     IF NOT (@V_DESC IS NULL) BEGIN

        INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                               IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                               DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                               DSMETUSUOPER, CDORESPOPER)
                    VALUES   ('UNIDMEDIDA', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                               @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                               @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                               @V_DSSERVMETHOD,   @V_DSREMOTEOPER);
     END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

    				 @V_SGUNIDADE_OLD,
    				 @V_DSUNIDADE_OLD,
    				 @V_DTULTATUUNID_OLD,

    				 @V_SGUNIDADE_NEW,
    				 @V_DSUNIDADE_NEW,
    				 @V_DTULTATUUNID_NEW;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_UNIDADE','6.05.xxx';
GO
